'***************************************************************
' IDAutomation OpenOffice Native Barcode Generator DEMO VERSION
' Tutorial: 
' http://www.idautomation.com/barcode-components/open-office-native-generator/user-manual.html
' 
'  Copyright 2015 IDAutomation.com, Inc. All rights reserved.
' USA Patent 7,637,436 B1
'
' DEMO VERSION NOTICE:
' The demo version of this product contains a static barcode that may be used for 
' evaluation purposes only. It may be exported or imported and used within OpenOffice
' to prove its functionality. The static barcode cannot be changed because this would
' reveal the complete source code, which is only available in the purchased version.
' The purchased version is provided with a 30 day money back satisfaction guarantee.
' If it is necessary to test dynamic barcodes with this product,
' the purchased version is required.
' www.idautomation.com/barcode-components/open-office-native-generator/
'
'***************************************************************

'START OF DECLARACTIONS
Option Explicit
Private I As Integer
Private J As Integer
Private DataToPrint As String
Private DataToEncode As String
Private OnlyCorrectData As String
Private Encoding As String
Private WeightedTotal As Long
Private WeightValue As Integer
Private CurrentValue As Long
Private CheckDigitValue As Integer
Private Factor As Integer
Private CheckDigit As Integer
Private CurrentEncoding As String
Private NewLine As String
Private msg As String
Private CurrentChar As String
Private CurrentCharNum As Integer
Private C128_StartA As String
Private C128_StartB As String
Private C128_StartC As String
Private C128_Stop As String
Private C128Start As String
Private C128CheckDigit As String
Private StartCode As String
Private StopCode As String
Private Fnc1 As String
Private LeadingDigit As Integer
Private EAN2AddOn As String
Private EAN5AddOn As String
Private EANAddOnToPrint As String
Private HumanReadableText As String
Private StringLength As Integer
Private Char1 As String
Private Char2 As String
Private nwPattern As String
Private CorrectFNC As Integer
Private Idx As Integer
Private PrintableString As String
Private DataToFormat As String
Dim MonoSpaceFont As Variant
Private ww As String
Private wb As String
Private bw As String
Private bb As String
Private SymbolString As String
Private SymbolStringLength As Integer
'Symbology set Arrays
Private SetC128() As Variant
Private SetITF() As Variant
Private Set39() As Variant
Private SetCODABAR() As Variant
Private SetMSI() As Variant
Private SetPostnet() As Variant
Private SetPlanet() As Variant
'END OF DECLARACTIONS


Public Function IDAutomation_NatG_C128DEMO(Optional DataToEncode As String, Optional BarHeight As Integer, Optional ApplyTilde As Boolean)
	'Set Optional Parameter Defaults, if missing
	If (IsMissing(DataToEncode) Or DataToEncode = "") Then
		DataToEncode = "0" 'Default value in Calc
	end if
	If (IsMissing(BarHeight) Or BarHeight < 1 Or BarHeight > 40) Then
		BarHeight = 6 
	end if
	If (IsMissing(ApplyTilde)) Then
		ApplyTilde = True 
	end if	
    CorrectFNC = 0
    'in case ApplyTilde is null, set it to false
    If ApplyTilde <> True Then ApplyTilde = False
    PrintableString = ""
	' DEMO VERSION NOTICE:
	' The demo version of this product contains a static barcode that may be used for 
	' evaluation purposes only. It may be exported or imported and used within OpenOffice
	' to prove its functionality. The static barcode cannot be changed because this would
	' reveal the complete source code, which is only available in the purchased version.
	' The purchased version is provided with a 30 day money back satisfaction guarantee.
	' If it is necessary to test dynamic barcodes with this product,
	' the purchased version is required.
	' http://www.idautomation.com/barcode-components/open-office-native-generator/    
    IDAutomation_NatG_C128DEMO = Universal_to_Native("EBDGCAAGCACGBNABMBCMAMIABAHBMBDEBCMAHABEFFAGCCECAIGCIEGEEGIAH", BarHeight)
End Function


Public Function IDAutomation_NatG_C128HR(Optional DataToFormat As String, Optional ApplyTilde As Boolean)
	'Set Optional Parameter Defaults, if missing
	If (IsMissing(DataToFormat) Or DataToFormat = "") Then
		DataToFormat = "0" 'Default value in Calc
	end if
	If (IsMissing(ApplyTilde)) Then
		ApplyTilde = True 
	end if	
   'DataToFormat = "81007123452112345678"
   Dim HumanReadableText As String
   DataToEncode = DataToFormat
   
    'Additions for ApplyTilde 2-11-2005
    If ApplyTilde Then
        OnlyCorrectData = ""
        StringLength = Len(DataToEncode)
        For I = 1 To StringLength
            If (I < StringLength - 2) And Mid(DataToEncode, I, 2) = "~m" And IsNum(Mid(DataToEncode, I + 2, 2)) Then
                WeightValue = Val(Mid(DataToEncode, I + 2, 2))
                If (I - WeightValue) < 1 Then WeightValue = I - 1
                CheckDigitValue = MODU10(Mid(DataToEncode, I - WeightValue, WeightValue))
                OnlyCorrectData = OnlyCorrectData & Chr(CheckDigitValue + 48)
                I = I + 3
            ElseIf (I < StringLength - 2) And Mid(DataToEncode, I, 1) = "~" And IsNum(Mid(DataToEncode, I + 1, 3)) Then
                CurrentCharNum = Val(Mid(DataToEncode, I + 1, 3))
                OnlyCorrectData = OnlyCorrectData & Chr(CurrentCharNum)
                I = I + 3
            Else
               OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, I, 1)
            End If
        Next I
        DataToEncode = OnlyCorrectData
    End If
   
   DataToFormat = DataToEncode
   DataToEncode = ""
   OnlyCorrectData = ""
   HumanReadableText = ""
   'FORMAT TEXT FOR AIs
    StringLength = Len(DataToFormat)
    For I = 1 To StringLength
        CorrectFNC = 0
        'Get ASCII value of each character
        CurrentCharNum = Asc(Mid(DataToFormat, I, 1))
        'Check for FNC1
        If ((I < StringLength - 2) And ((CurrentCharNum = 202) Or ((CurrentCharNum > 211) And (CurrentCharNum < 219)))) Then
            'Updated the next if/else by BDA on 12-2005 to eliminate errors from text after the AI
            'It appears that there is an AI
            'Get the value of the next 2 digits to try to determine the length of the AI, if text is used here
            'Set this value to 81 for a 4 digit AI
            If IsNum(Mid(DataToFormat, I + 1, 1)) And IsNum(Mid(DataToFormat, I + 2, 1)) Then
                CurrentChar = Mid(DataToFormat, I + 1, 2)
                CurrentCharNum = CInt(CurrentChar)
            Else
                CurrentCharNum = 81
            End If
            'Is 2 digit AI by entering ASCII 212?
            If ((CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 212)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 2)) & ") "
                I = I + 2
                CorrectFNC = 1
            'Is 3 digit AI by entering ASCII 213?
            ElseIf ((I < StringLength - 3) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 213)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 3)) & ") "
                I = I + 3
                CorrectFNC = 1
            'Is 4 digit AI by entering ASCII 214?
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 214)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            'Is 5 digit AI by entering ASCII 215?
            ElseIf ((I < StringLength - 5) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 215)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 5)) & ") "
                I = I + 5
                CorrectFNC = 1
            'Is 6 digit AI by entering ASCII 216?
            ElseIf ((I < StringLength - 6) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 216)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 6)) & ") "
                I = I + 6
                CorrectFNC = 1
            'Is 7 digit AI by entering ASCII 217?
            ElseIf ((I < StringLength - 7) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 217)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 7)) & ") "
                I = I + 7
                CorrectFNC = 1
            'Is 8 digit AI by entering ASCII 218?
            ElseIf ((I < StringLength - 8) And (CorrectFNC = 0) And (Asc(Mid(DataToFormat, I, 1)) = 218)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 8)) & ") "
                I = I + 8
                CorrectFNC = 1
            'Is 4 digit AI by detection?
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0) And ((CurrentCharNum <= 81 And CurrentCharNum >= 80) Or (CurrentCharNum <= 34 And CurrentCharNum >= 31))) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            'Is 3 digit AI by detection?
            ElseIf ((I < StringLength - 3) And (CorrectFNC = 0) And ((CurrentCharNum <= 49 And CurrentCharNum >= 40) Or (CurrentCharNum <= 25 And CurrentCharNum >= 23))) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 3)) & ") "
                I = I + 3
                CorrectFNC = 1
            'Is 2 digit AI by detection?
            ElseIf ((CurrentCharNum <= 30 And (CorrectFNC = 0) And CurrentCharNum >= 0) Or (CurrentCharNum <= 99 And CurrentCharNum >= 90)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 2)) & ") "
                I = I + 2
                CorrectFNC = 1
            'If no AI was detected, set default to 4 digit AI:
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            End If
        ElseIf (Asc(Mid(DataToFormat, I, 1)) = 197) Then
            HumanReadableText = HumanReadableText & " "
        ElseIf (Asc(Mid(DataToFormat, I, 1)) < 32) Then
            HumanReadableText = HumanReadableText & " "
        ElseIf ((Asc(Mid(DataToFormat, I, 1)) > 31) And (Asc(Mid(DataToFormat, I, 1)) < 128)) Then
            HumanReadableText = HumanReadableText & Mid(DataToFormat, I, 1)
        End If
    Next I
    DataToFormat = ""
    IDAutomation_NatG_C128HR = HumanReadableText
End Function


Public Function IDAutomation_NatG_SpliceText(Optional DataToFormat As String, Optional SpacingNumber As Integer, Optional ApplyTilde As Boolean) As String
	'Set Optional Parameter Defaults, if missing
	If (IsMissing(DataToFormat) Or DataToFormat = "") Then
		DataToFormat = "0" 'Default value in Calc
	end if
	If (IsMissing(SpacingNumber) Or SpacingNumber = "") Then
		SpacingNumber = 4 'Default value in Calc
	end if	
	If (IsMissing(ApplyTilde)) Then
		ApplyTilde = True 
	end if	

    If ApplyTilde Then
        DataToEncode = DataToFormat
        DataToFormat = ""
        OnlyCorrectData = ""
        StringLength = Len(DataToEncode)
        For I = 1 To StringLength
            If (I < StringLength - 2) And Mid(DataToEncode, I, 2) = "~m" And IsNum(Mid(DataToEncode, I + 2, 2)) Then
                WeightValue = Val(Mid(DataToEncode, I + 2, 2))
                If (I - WeightValue) < 1 Then WeightValue = I - 1
                CheckDigitValue = MODU10(Mid(DataToEncode, I - WeightValue, WeightValue))
                OnlyCorrectData = OnlyCorrectData & Chr(CheckDigitValue + 48)
                I = I + 3
            ElseIf (I < StringLength - 2) And Mid(DataToEncode, I, 1) = "~" And IsNum(Mid(DataToEncode, I + 1, 3)) Then
                CurrentCharNum = Val(Mid(DataToEncode, I + 1, 3))
                OnlyCorrectData = OnlyCorrectData & Chr(CurrentCharNum)
                I = I + 3
            Else
               OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, I, 1)
            End If
        Next I
        DataToFormat = OnlyCorrectData
        DataToEncode = ""
    End If
    'inserting a space for every SpacingNumber of characters
    HumanReadableText = ""
    StringLength = Len(DataToFormat)
    J = 0
    For I = 1 To StringLength
        CurrentCharNum = Asc(Mid(DataToFormat, I, 1))
        If CurrentCharNum > 31 And CurrentCharNum < 128 Then
            HumanReadableText = HumanReadableText & Mid(DataToFormat, I, 1)
            J = J + 1
        End If
        If (J Mod SpacingNumber) = 0 Then HumanReadableText = HumanReadableText & " "
    Next I
    IDAutomation_NatG_SpliceText = HumanReadableText
End Function


Public Function Universal_to_Native(DataToPrint As String, Optional BarHeight As Integer) As String
	'This product is protected by copyright and US Patent 7,637,436 B1. 
	'This technology may only be used in production with the purchase of a license
	'to the Native Barcode Generator:
	'www.idautomation.com/barcode-components/open-office-native-generator/
    If BarHeight < 1 Or BarHeight > 40 Then BarHeight = 6
    MonoSpaceFont = True
    SymbolString = ""
    StringLength = Len(DataToPrint)
    For I = 1 To StringLength
        'Get the value of each
        CurrentCharNum = Asc(Mid(DataToPrint, I, 1))
        If CurrentCharNum >= 65 And CurrentCharNum <= 68 Then SymbolString = SymbolString & CStr((11 + (CurrentCharNum - 65)))
        If CurrentCharNum >= 69 And CurrentCharNum <= 72 Then SymbolString = SymbolString & CStr((21 + (CurrentCharNum - 69)))
        If CurrentCharNum >= 73 And CurrentCharNum <= 76 Then SymbolString = SymbolString & CStr((31 + (CurrentCharNum - 73)))
        If CurrentCharNum >= 77 And CurrentCharNum <= 80 Then SymbolString = SymbolString & CStr((41 + (CurrentCharNum - 77)))
        If CurrentCharNum >= 87 And CurrentCharNum <= 88 Then SymbolString = SymbolString & CStr((11 + (CurrentCharNum - 87)))
        If CurrentCharNum >= 89 And CurrentCharNum <= 90 Then SymbolString = SymbolString & CStr((21 + (CurrentCharNum - 89)))
    Next I
    'SymbolString to Native Conversion
    'At this point in the code, SymbolString is the entire barcode string in number form
    'For example: 211214142112214121221114311321211232
    'Convert SymbolString to PrintableString
    ww = Chr(32) 'SPACE
    If MonoSpaceFont = False Then ww = Chr(32) & Chr(32) & Chr(32)
    wb = Chr(9616)
    bw = Chr(9612)
    bb = Chr(9608)
    CurrentValue = 0
    PrintableString = ""
    Universal_to_Native = ""
    Dim NextDigitUsed As Integer
    Dim StartOver As Integer
    NextDigitUsed = 0
    Factor = 3
    Dim SymbolStringLength
    SymbolStringLength = Len(SymbolString) - 1
    For I = 1 To SymbolStringLength
        CurrentValue = Val(Mid(SymbolString, I, 1))
        If NextDigitUsed = 1 Then
            If CurrentValue > 1 Then
                CurrentValue = CurrentValue - 1
                NextDigitUsed = 0
            Else
                NextDigitUsed = 1
            End If
        End If
        If NextDigitUsed = 1 And CurrentValue = 1 Then
            NextDigitUsed = 0
        Else
            For J = 1 To CurrentValue
                If J = CurrentValue Then
                    NextDigitUsed = 1
                    If Factor = 3 Then PrintableString = PrintableString & bw
                    If Factor = 1 Then PrintableString = PrintableString & wb
                Else
                    NextDigitUsed = 0
                    If Factor = 3 Then PrintableString = PrintableString & bb
                    If Factor = 1 Then PrintableString = PrintableString & ww
                    J = J + 1
                End If
            Next J
        End If
        Factor = 4 - Factor
    Next I
    For I = 1 To BarHeight
	    If I = 1 Then 
	    	Universal_to_Native = PrintableString
	    Else
	    	Universal_to_Native = Universal_to_Native & Chr(13) & Chr(10) & PrintableString
	    End If
    Next I
    'String for the Universal Font = DataToPrint
    'String for the SymbolString = SymbolString
End Function



Public Function IsNum(StringToCheck As String) As Boolean
	'This function was created to resolved an IsNumeric bug that exists in some versions of OO VB. 
	'If IsNumeric() contains a leading space or dash symbol the function thinks it is a number when it should not be:
	'IsNumeric(1234)=True
	'IsNumeric(12 34)=False
	'IsNumeric( 1234)=True (should be False)
	'IsNumeric(-1234)=True (should be False)
	If (IsMissing(StringToCheck) Or StringToCheck = "") Then
		StringToCheck = "T" 'in order to return false
	End If
	if Mid(StringToCheck, 1, 1) = " " or Mid(StringToCheck, 1, 1) = "-" Then
		IsNum = False
	Else
		IsNum = IsNumeric(StringToCheck)
	End If
End Function



